# coding: utf-8

"""
    LINE Messaging API

    This document describes LINE Messaging API.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic.v1 import Field
from linebot.v3.messaging.models.mention_target import MentionTarget
from linebot.v3.messaging.models.substitution_object import SubstitutionObject

class MentionSubstitutionObject(SubstitutionObject):
    """
    An object representing a mention substitution.
    https://developers.line.biz/en/reference/messaging-api/#text-message-v2-mention-object
    """
    mentionee: MentionTarget = Field(...)
    type: str = "mention"

    __properties = ["type", "mentionee"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MentionSubstitutionObject:
        """Create an instance of MentionSubstitutionObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic.v1 by calling `to_dict()` of mentionee
        if self.mentionee:
            _dict['mentionee'] = self.mentionee.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MentionSubstitutionObject:
        """Create an instance of MentionSubstitutionObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MentionSubstitutionObject.parse_obj(obj)

        _obj = MentionSubstitutionObject.parse_obj({
            "type": obj.get("type"),
            "mentionee": MentionTarget.from_dict(obj.get("mentionee")) if obj.get("mentionee") is not None else None
        })
        return _obj

